=== debian/control ===
Source: ros-melodic-slam-toolbox
Section: misc
Priority: optional
Maintainer: Steve Macenski <stevenmacenski@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libeigen3-dev, liblapack-dev, libqt5core5a, libqt5widgets5, libsuitesparse-dev, libtbb-dev, qtbase5-dev, ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-interactive-markers, ros-melodic-libg2o, ros-melodic-map-server, ros-melodic-message-filters, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-slam-toolbox-msgs, ros-melodic-sparse-bundle-adjustment, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-slam-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libeigen3-dev, liblapack-dev, libqt5core5a, libqt5widgets5, libsuitesparse-dev, libtbb-dev, ros-melodic-interactive-markers, ros-melodic-libg2o, ros-melodic-map-server, ros-melodic-message-filters, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-slam-toolbox-msgs, ros-melodic-sparse-bundle-adjustment, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Description: This package provides a sped up improved slam karto with updated SDK and visualization and modification toolsets
